// Copyright  2007 Konesans Ltd.  For educational purposes only. Distribution in any form is strictly forbidden.

#region Using directives

using System;
using System.Drawing.Design;
using System.ComponentModel;
using System.Windows.Forms.Design;
using Microsoft.SqlServer.Dts.Runtime.Design;

#endregion

namespace Konesans.Dts.Runtime.SimpleTask5
{
    /// <summary>
    /// Dts Input Type Editor for FILE connections. Cut down demo only.
    /// </summary>
    public class FileConnectionTypeEditor : UITypeEditor, IDisposable
    {
        #region Private Variables
        private FileConnectionTypeEditorControl _editorControl;
        #endregion

        #region UITypeEditor Members

        #region GetEditStyle
        public override UITypeEditorEditStyle GetEditStyle(ITypeDescriptorContext context)
        {
                return UITypeEditorEditStyle.DropDown;
        }
        #endregion

        #region EditValue
        public override object EditValue(ITypeDescriptorContext context, IServiceProvider provider, object value)
        {
            // IDtsConnectionService requires reference to Microsoft.SQLServer.Dts.Design

            IDtsConnectionService dtsConnectionService = provider.GetService(typeof(IDtsConnectionService)) as IDtsConnectionService;

            IWindowsFormsEditorService windowsFormsEditorService = (IWindowsFormsEditorService)provider.GetService(typeof(IWindowsFormsEditorService));

                // Create our UI control
                if (_editorControl == null)
                    _editorControl = new FileConnectionTypeEditorControl(dtsConnectionService, windowsFormsEditorService);
                
                if (value != null)
                    _editorControl.Text = value.ToString();

                _editorControl.PopulateConnectionsCombo(null);

                windowsFormsEditorService.DropDownControl(_editorControl);

                return _editorControl.Text;            
        }
        #endregion

        #region IsDropDownResizable
        /// <summary>
        /// Get a value indicating whether the drop-down is resizable. (True)
        /// </summary>
        public override bool IsDropDownResizable
        {
            get { return true; }
        }
        #endregion

        #endregion

        #region IDisposable Members

        /// <summary>
        /// Dispose of DtsInputTypeEditor.
        /// </summary>
        public void Dispose()
        {
            _editorControl.Dispose();
        }

        #endregion
    }
}
