// Copyright  2007 Konesans Ltd.  For educational purposes only. Distribution in any form is strictly forbidden.

#region Using directives

using System.Windows.Forms;
using Microsoft.SqlServer.Dts.Runtime;
using Microsoft.SqlServer.Dts.Runtime.Design;

#endregion

namespace Konesans.Dts.Runtime.SimpleTask5
{
    public class SimpleTaskUI : IDtsTaskUI
    {
        #region Private variables
        // Private variables, cache them between Initialize and GetView
        private TaskHost _taskHost = null;
        private IDtsConnectionService _dtsConnectionService = null;
        #endregion

        #region Initialize
        /// <summary>
        /// Initialize UI control
        /// </summary>
        /// <param name="taskHost">TaskHost</param>
        /// <param name="serviceProvider">IServiceProvider</param>
        public void Initialize(TaskHost taskHost, System.IServiceProvider serviceProvider)
        {
            _taskHost = taskHost;
            _dtsConnectionService = serviceProvider.GetService(typeof(IDtsConnectionService)) as IDtsConnectionService;
        }
        #endregion

        #region GetView
        /// <summary>
        /// Called by designer to show the UI Form
        /// </summary>
        /// <returns>ContainerControl of UI Form</returns>
        public ContainerControl GetView()
        {
            return new SimpleTaskUIForm(_taskHost, _dtsConnectionService);
        }
        #endregion

        #region New
        /// <summary>
        ///  Called when task is first added to the package
        /// </summary>
        public void New(IWin32Window parentWindow)
        {
            // Nothing required.
        }
        #endregion

        #region Delete
        /// <summary>
        ///  Called when task is deleted from the package
        /// </summary>
        public void Delete(IWin32Window parentWindow)
        {
            // Nothing required.
        }
        #endregion
    }
}
